import { BaseCustomWebComponentConstructorAppend } from '@node-projects/base-custom-webcomponent';
import { ITreeView, InstanceServiceContainer, IDesignItem, ContextMenu, ISelectionChangedEvent } from '@node-projects/web-component-designer';
export declare class TreeViewExtended extends BaseCustomWebComponentConstructorAppend implements ITreeView {
    private _treeDiv;
    private _tree;
    private _filter;
    private _instanceServiceContainer;
    private _selectionChangedHandler;
    private _contentChangedHandler;
    static readonly style: CSSStyleSheet;
    static readonly template: HTMLTemplateElement;
    constructor();
    _filterNodes(): void;
    _showHideAtDesignTimeState(img: HTMLImageElement, designItem: IDesignItem): void;
    _switchHideAtDesignTimeState(img: HTMLImageElement, designItem: IDesignItem): void;
    _showLockAtDesignTimeState(img: HTMLImageElement, designItem: IDesignItem): void;
    _switchLockAtDesignTimeState(img: HTMLImageElement, designItem: IDesignItem): void;
    _showHideAtRunTimeState(img: HTMLImageElement, designItem: IDesignItem): void;
    _switchHideAtRunTimeState(img: HTMLImageElement, designItem: IDesignItem): void;
    showDesignItemContextMenu(designItem: IDesignItem, event: MouseEvent): ContextMenu;
    ready(): Promise<void>;
    createTree(rootItem: IDesignItem): void;
    set instanceServiceContainer(value: InstanceServiceContainer);
    selectionChanged(event: ISelectionChangedEvent): void;
    private _recomputeTree;
    private _getChildren;
    private _highlight;
}
